# coding: utf-8

"""
    VMware Aria Automation Assembler / CMX Service API

    When using Kubernetes integration, deploy and manage Kubernetes clusters and namespaces. The APIs that list collections of resources also support OData like implementation. Below query params can be used across CMX entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/cmx/api/resources/tags?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/cmx/api/resources/tags?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/cmx/api/resources/tags?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /cmx/api/resources/tags?$filter=startswith(name, 'K8S')   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CmxapiresourcessupervisornamespacesStoragePolicies(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'desc': 'str',
        'document_self_link': 'str',
        'id': 'str',
        'limit': 'int',
        'name': 'str'
    }

    attribute_map = {
        'desc': 'desc',
        'document_self_link': 'documentSelfLink',
        'id': 'id',
        'limit': 'limit',
        'name': 'name'
    }

    def __init__(self, desc=None, document_self_link=None, id=None, limit=None, name=None):  # noqa: E501
        """CmxapiresourcessupervisornamespacesStoragePolicies - a model defined in Swagger"""  # noqa: E501
        self._desc = None
        self._document_self_link = None
        self._id = None
        self._limit = None
        self._name = None
        self.discriminator = None
        if desc is not None:
            self.desc = desc
        if document_self_link is not None:
            self.document_self_link = document_self_link
        if id is not None:
            self.id = id
        if limit is not None:
            self.limit = limit
        if name is not None:
            self.name = name

    @property
    def desc(self):
        """Gets the desc of this CmxapiresourcessupervisornamespacesStoragePolicies.  # noqa: E501


        :return: The desc of this CmxapiresourcessupervisornamespacesStoragePolicies.  # noqa: E501
        :rtype: str
        """
        return self._desc

    @desc.setter
    def desc(self, desc):
        """Sets the desc of this CmxapiresourcessupervisornamespacesStoragePolicies.


        :param desc: The desc of this CmxapiresourcessupervisornamespacesStoragePolicies.  # noqa: E501
        :type: str
        """

        self._desc = desc

    @property
    def document_self_link(self):
        """Gets the document_self_link of this CmxapiresourcessupervisornamespacesStoragePolicies.  # noqa: E501


        :return: The document_self_link of this CmxapiresourcessupervisornamespacesStoragePolicies.  # noqa: E501
        :rtype: str
        """
        return self._document_self_link

    @document_self_link.setter
    def document_self_link(self, document_self_link):
        """Sets the document_self_link of this CmxapiresourcessupervisornamespacesStoragePolicies.


        :param document_self_link: The document_self_link of this CmxapiresourcessupervisornamespacesStoragePolicies.  # noqa: E501
        :type: str
        """

        self._document_self_link = document_self_link

    @property
    def id(self):
        """Gets the id of this CmxapiresourcessupervisornamespacesStoragePolicies.  # noqa: E501


        :return: The id of this CmxapiresourcessupervisornamespacesStoragePolicies.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CmxapiresourcessupervisornamespacesStoragePolicies.


        :param id: The id of this CmxapiresourcessupervisornamespacesStoragePolicies.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def limit(self):
        """Gets the limit of this CmxapiresourcessupervisornamespacesStoragePolicies.  # noqa: E501


        :return: The limit of this CmxapiresourcessupervisornamespacesStoragePolicies.  # noqa: E501
        :rtype: int
        """
        return self._limit

    @limit.setter
    def limit(self, limit):
        """Sets the limit of this CmxapiresourcessupervisornamespacesStoragePolicies.


        :param limit: The limit of this CmxapiresourcessupervisornamespacesStoragePolicies.  # noqa: E501
        :type: int
        """

        self._limit = limit

    @property
    def name(self):
        """Gets the name of this CmxapiresourcessupervisornamespacesStoragePolicies.  # noqa: E501


        :return: The name of this CmxapiresourcessupervisornamespacesStoragePolicies.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CmxapiresourcessupervisornamespacesStoragePolicies.


        :param name: The name of this CmxapiresourcessupervisornamespacesStoragePolicies.  # noqa: E501
        :type: str
        """

        self._name = name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CmxapiresourcessupervisornamespacesStoragePolicies, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CmxapiresourcessupervisornamespacesStoragePolicies):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
